var DATA_START = {
    sweeps: "",
    language: "",
    email: "",
    getFinalString: function () {
        return this.sweeps.concat(this.language);
    },
};

var submitCounter = 1;

$(document).ready(function () {
    $mz.onload();

    MZvalidStyle();
    console.log(document.getElementById("touchBegin"));

    // buttonClick("#touchBegin", getData_Sweeps);
    // buttonClick("#startButton", getData_Sweeps);
    // buttonClick("#sweepsStartButton", getData_SweepsMandatory);
    buttonClick("#cont1", getData_Language);
    buttonClick("#contRegCk", getData_Email);
});

initializeListeners();

function initializeListeners() {
    utilities.getRadioInputByName("language").on("click", handleLanguageChange);
}

function handleLanguageChange(event) {
    switch (event.target.value) {
        case "English":
            setLanguage("English");
            break;

        case "Spanish":
            setLanguage("Spanish");
            break;

        default:
            break;
    }
}

// function getData_Sweeps() {
// 	DATA_START.sweeps = BuildResult(window.document, "mozeus");
// 	console.log(DATA_START.sweeps);

// 	advance();
// }

function getData_SweepsMandatory() {
    console.log("mandat");
    if (utilities.validateCheckboxInputByName("OptIn")) {
        DATA_START.sweeps = BuildResult(this.document, "mozeus");
        console.log(DATA_START.sweeps);

        advance();
    } else {
        $(".form__label-checkbox").addClass("mz-invalid-color");
    }
}

function getData_Language() {
    if (utilities.validateRadioInputByName("language")) {
        $("#languageQuestion h1").removeClass("mz-invalid-color");
        if (submitCounter === 1) {
            submitCounter++;

            DATA_START.language = BuildResult(this.document, "mozeus1");
            console.log(DATA_START.language);

            let submitString = DATA_START.getFinalString();

            console.log(submitString);
            SubmitResultString(submitString);
        }
    } else {
        $("#languageQuestion h1").addClass("mz-invalid-color");
    }
}

function getData_Email() {
    $("#submitGo1").blur();
    document.activeElement.blur();

    var goBtn = document.getElementById("submitGo1");
    var btn = document.getElementById("contRegCk");

    if (validate_Email()) {
        //clearing timeout/listeners
        $("body").off();

        // clearTimeout(masterTimeout);

        //This is the Email verification function

        function callBack(isvalid) {
            console.log("Valid = " + isvalid);
            try {
                console.log("Callback Try");

                // btn.src = "ba-toyota-button_next.png";
                $mz.find("validCover").style.display = "none";

                if (isvalid) {
                    console.log("is valid is true");

                    proceed();
                } else {
                    console.log("is valid is NOT true");

                    var alertElem = $mz.validate.getInvalidMsgElemId($mz.find("mz_Email"));

                    alertElem = typeof alertElem !== "undefined" && alertElem !== null && alertElem.trim() !== "" ? alertElem : null;
                    if (alertElem !== null && $mz.find(alertElem) !== null) {
                        $mz.find(alertElem).style.display = isvalid ? "none" : "block";
                        $("#mz_Email").addClass("invalid-border");
                    }
                }
            } catch (e) {
                console.log("Callback Catch");

                proceed();
            }
            btn.disabled = false;
            goBtn.disabled = false;
            btn.classList.remove("disabledEmail");
            if (language === "Spanish") {
                btn.innerHTML = "Continuar";
            } else {
                btn.innerHTML = "Next";
            }
        }

        try {
            console.log("Try");
            btn.classList.add("disabledEmail");
            btn.innerHTML = "";
            btn.disabled = true;
            goBtn.disabled = true;
            $mz.find("validCover").style.display = "none";
            $mz.validate.emailByOnlineService($mz.find("mz_Email"), callBack);
        } catch (e) {
            console.log("Catch");
            if ($mz.validate.element($mz.find("mz_Email"))) {
                $mz.find("validCover").style.display = "none";
                $("#mz_Email").removeClass("invalid-border");
                proceed();
            }
            $mz.find("validCover").style.display = "none";
            btn.disabled = false;
            goBtn.disabled = false;
            btn.classList.remove("disabledEmail");
            if (language === "Spanish") {
                btn.innerHTML = "Siguiente";
            } else {
                btn.innerHTML = "Next";
            }
            $("#mz_Email").removeClass("invalid-border");
        }

        //This is the main submit function, outside of email verification
        function proceed() {
            var emailValue = document.getElementById("mz_Email").value;
            DATA_START.email = "Email=" + emailValue + ";";

            console.log("submit = " + DATA_START.getFinalString());
            SubmitResultString(DATA_START.getFinalString());
        }

        // var emailValue = document.getElementById('mz_Email').value;
        // DATA_START.email = 'Email=' + emailValue + ";";
        //
        // console.log('submit = ' + DATA_START.getFinalString());
        // SubmitResultString(DATA_START.getFinalString());
    }
}

function validate_Email() {
    document.activeElement.blur();

    var email = $mz.validate.element($mz.find("mz_Email"));

    return email;
}

function validate_TrueEmail() {
    if (validate_Email()) {
        //This is the Email verification function
        try {
            console.log("Try");
            btn.classList.add("disabledEmail");
            btn.innerHTML = "";
            btn.disabled = true;
            goBtn.disabled = true;
            $mz.find("validCover").style.display = "none";
            $mz.validate.emailByOnlineService($mz.find("mz_Email"), mz_validateEmailCall);
        } catch (e) {
            console.log("Catch");
            if ($mz.validate.element($mz.find("mz_Email"))) {
                $mz.find("validCover").style.display = "none";
                $("#mz_Email").removeClass("invalid-border");
                getData_Email();
            }
            $mz.find("validCover").style.display = "none";
            btn.disabled = false;
            goBtn.disabled = false;
            btn.classList.remove("disabledEmail");
            if (language === "Spanish") {
                btn.innerHTML = "Siguiente";
            } else {
                btn.innerHTML = "Next";
            }
            $("#mz_Email").removeClass("invalid-border");
        }
    }
}

function mz_validateEmailCall(isvalid) {
    console.log("Valid = " + isvalid);
    try {
        console.log("Callback Try");

        // btn.src = "ba-toyota-button_next.png";
        $mz.find("validCover").style.display = "none";

        if (isvalid) {
            console.log("is valid is true");

            getData_ConsumerData();
        } else {
            console.log("is valid is NOT true");

            var alertElem = $mz.validate.getInvalidMsgElemId($mz.find("mz_Email"));

            alertElem = typeof alertElem !== "undefined" && alertElem !== null && alertElem.trim() !== "" ? alertElem : null;
            if (alertElem !== null && $mz.find(alertElem) !== null) {
                $mz.find(alertElem).style.display = isvalid ? "none" : "block";
                $("#mz_Email").addClass("invalid-border");
            }
        }
    } catch (e) {
        console.log("Callback Catch");

        getData_ConsumerData();
    }
    btn.disabled = false;
    goBtn.disabled = false;
    btn.classList.remove("disabledEmail");
    if (language === "Spanish") {
        btn.innerHTML = "Continuar";
    } else {
        btn.innerHTML = "Next";
    }
}
